__author__ = 'DarkWeb'

# Here, we are importing the auxiliary functions to clean or convert data
from MarketPlaces.Utilities.utilities import *

# Here, we are importing BeautifulSoup to search through the HTML tree
from bs4 import BeautifulSoup
import re


# parses description pages, so takes html pages of description pages using soup object, and parses it for info it needs
# stores info it needs in different lists, these lists are returned after being organized
# @param: soup object looking at html page of description page
# return: 'row' that contains a variety of lists that each hold info on the description page
def zeroday_description_parser(soup):
    # Fields to be parsed

    vendor = "-1"  # 0 *Vendor_Name y
    success = "-1"  # 1 Vendor_Successful_Transactions n
    rating_vendor = "-1"  # 2 Vendor_Rating y
    name = "-1"  # 3 *Product_Name y
    describe = "-1"  # 4 Product_Description y
    CVE = "-1"  # 5 Product_CVE_Classification (Common Vulnerabilities and Exposures)
    MS = "-1"  # 6 Product_MS_Classification (Microsoft Security)
    category = "-1"  # 7 Product_Category y
    views = "-1"  # 8 Product_Number_Of_Views y
    reviews = "-1"  # 9 Product_Number_Of_Reviews n
    rating_item = "-1"  # 10 Product_Rating n
    addDate = "-1"  # 11 Product_AddedDate y
    BTC = "-1"  # 12 Product_BTC_SellingPrice y
    USD = "-1"  # 13 Product_USD_SellingPrice y
    EURO = "-1"  # 14 Product_EURO_SellingPrice n
    sold = "-1"  # 15 Product_QuantitySold n
    left = "-1"  # 16 Product_QuantityLeft n
    shipFrom = "-1"  # 17 Product_ShippedFrom n
    shipTo = "-1"  # 18 Product_ShippedTo n
    image = "-1"  # 19 Product_Image n
    vendor_image = "-1"  # 20 Vendor_Image n

    # Finding Vendor
    div_vendor = soup.find('div', {'class': "exploit_view_table_user_content"})
    vendor = div_vendor.find('a').text
    vendor = cleanString(vendor).strip()

    # Finding Vendor Rating (bug in their system shows standard rating)
    div_rating = div_vendor.find_next_sibling('div')
    rating_vendor = div_rating.find_all('div', {'class': "td"})[1].text
    rating_vendor = cleanNumbers(rating_vendor).strip()

    # Finding Product Name
    div_name = soup.find('div', {'class': "exploit_title"})
    name = div_name.find('h1', {'class': "YellowText"}).text
    name = cleanString(name).strip()

    # Finding Product description
    describe = soup.find('meta', attrs={'name': "description"}).get("content")
    describe = cleanString(describe).strip()

    # Searching for CVE and MS categories
    cve = soup.findAll(text=re.compile('CVE-\d{4}-\d{4}'))
    if cve:
        CVE = " "
        for idx in cve:
            CVE += (idx)
            CVE += "  "
            CVE = CVE.replace(',', ' ')
            CVE = CVE.replace('\n', '')
            CVE = CVE.replace('\t', '')
    ms = soup.findAll(text=re.compile('MS\d{2}-\d{3}'))
    if ms:
        MS = " "
        for im in ms:
            MS += (im)
            MS += " "
            MS = MS.replace(',', ' ')
            MS = MS.replace('\n', '')

    # Finding category
    div_category = soup.find('div', {'class': "td"}, text="Category").find_next_sibling('div', {'class': "td"})
    category = div_category.text
    category = cleanString(category).strip()

    # Finding views
    div_views = soup.find('div', {'class': "td"}, text="Views").find_next_sibling('div', {'class': "td"})
    views = div_views.text.replace(' ', '').strip()

    # Finding added date
    div_date = soup.find('div', {'class': 'td'}, text='Date add').find_next_sibling('div', {'class': "td"})
    addDate = div_date.text.strip()
    # addDate = datetime.strptime(addDate, "%d-%m-%Y")

    # Finding BTC and USD/GOLD
    div_price = soup.find('div', {'class': "td"}, text="Price")
    price = div_price.find_next_sibling('div', {'class': "td"}).text.strip()

    if "free" in price.lower():
        BTC = 0
        USD = 0
    else:
        price = ''.join(price.split())
        index = price.index('BTC')
        BTC = price[:index]
        USD = price[index + 3:].replace('USD', '')

    # Populating the final variable (this should be a list with all fields scraped)
    row = (vendor, rating_vendor, success, name, describe, CVE, MS, category, views, reviews, rating_item, addDate,
           BTC, USD, EURO, sold, left, shipFrom, shipTo, image, vendor_image)

    # Sending the results
    return row


# parses listing pages, so takes html pages of listing pages using soup object, and parses it for info it needs
# stores info it needs in different lists, these lists are returned after being organized
# @param: soup object looking at html page of listing page
# return: 'row' that contains a variety of lists that each hold info on the listing page
def zeroday_listing_parser(soup):
    # Fields to be parsed
    nm = 0  # *Total_Products (Should be Integer)
    mktName = "ZeroDay"  # 0 *Marketplace_Name y
    vendor = []  # 1 *Vendor y
    rating_vendor = []  # 2 Vendor_Rating y
    success = []  # 3 Vendor_Successful_Transactions n
    name = []  # 4 *Product_Name y
    CVE = []  # 5 Product_CVE_Classification (Common Vulnerabilities and Exposures) dont worry about this
    MS = []  # 6 Product_MS_Classification (Microsoft Security) dont worry about this
    category = []  # 7 Product_Category y
    describe = []  # 8 Product_Description n
    views = []  # 9 Product_Number_Of_Views y
    reviews = []  # 10 Product_Number_Of_Reviews n
    rating_item = []  # 11 Product_Rating n
    addDate = []  # 12 Product_AddDate y
    BTC = []  # 13 Product_BTC_SellingPrice y
    USD = []  # 14 Product_USD_SellingPrice y
    EURO = []  # 15 Product_EURO_SellingPrice n
    sold = []  # 16 Product_QuantitySold n
    qLeft = []  # 17 Product_QuantityLeft n
    shipFrom = []  # 18 Product_ShippedFrom n
    shipTo = []  # 19 Product_ShippedTo n
    image = []  # 20 Product_Image n
    image_vendor = []  # 21 Vendor_Image n
    href = []  # 22 Product_Links y

    listings = soup.findAll('div', {"class": "ExploitTableContent"})

    # Populating the Number of Products
    nm = len(listings)

    for listing in listings:
        # Finding the vendor name
        vendor_name = listing.find('a', href=lambda href: href and '/author/' in href).text
        vendor_name = cleanString(vendor_name).strip()
        vendor.append(vendor_name)

        # Finding the vendor rating
        vendor_level_div = listing.find('div', {'class': "tips_bl"})
        vendor_level = vendor_level_div.find('div', {'class': "tips_value_big"}).text
        vendor_level = cleanNumbers(vendor_level)
        rating_vendor.append(vendor_level)

        # Finding the product name
        product_name = listing.find('h3').text
        product_name = cleanString(product_name).strip()
        name.append(product_name)

        # Searching for CVE and MS categories
        cve = listing.findAll(text=re.compile('CVE-\d{4}-\d{4}'))
        if not cve:
            cveValue = "-1"
        else:
            cee = " "
            for idx in cve:
                cee += (idx)
                cee += "  "
                cee = cee.replace(',', ' ')
                cee = cee.replace('\n', '')
                cee = cee.replace('\t', '')
            cveValue = cee
        CVE.append(cveValue)

        ms = listing.findAll(text=re.compile('MS\d{2}-\d{3}'))
        if not ms:
            MSValue = "-1"
        else:
            me = " "
            for im in ms:
                me += (im)
                me += " "
                me = me.replace(',', ' ')
                me = me.replace('\n', '')
            MSValue = me
        MS.append(MSValue)

        # Finding the category
        category_text = listing.find_all('div', {'class': "td"})[2].text
        category_text = cleanString(category_text).strip()
        category.append(category_text)

        # Finding the hrefs
        description_link = listing.find('h3').find('a')['href']
        href.append(description_link)

        # Finding the views
        views_text = listing.find_all('div', {'class': "td"})[3].text.replace(' ', '').strip()
        views.append(views_text)

        # Finding the date added
        date = listing.find('div', {'class': "td"}).find('a').text.strip()
        # date = datetime.strptime(date, "%d-%m-%Y")
        addDate.append(date)

        # Finding the BTC and USD/GOLD
        btc_listing = listing.find('div', {"class": 'tips_price_btc'})
        if btc_listing:
            btc_price = btc_listing.text.strip().replace('Open this exploit for ', '').replace(' BTC', '')
            crossed = btc_listing.find('span', {'class': "crossed"})
            if crossed:
                btc_price = crossed.next_sibling.strip().replace(' BTC', '')
        else:
            btc_price = 0
        BTC.append(btc_price)

        usd_listing = listing.find('div', {"class": 'tips_price_1'})
        if usd_listing:
            usd_price = usd_listing.text.strip().replace('Open this exploit for ', '').replace(' GOLD', '')
            crossed = usd_listing.find('span', {'class': "crossed"})
            if crossed:
                usd_price = crossed.next_sibling.strip().replace(' GOLD', '')
            usd_price = ''.join(usd_price.replace(' ', ''))
        else:
            usd_price = 0
        USD.append(usd_price)

    # Populate the final variable (this should be a list with all fields scraped)
    return organizeProducts(mktName, nm, vendor, rating_vendor, success, name, CVE, MS, category, describe, views,
                            reviews, rating_item, addDate, BTC, USD, EURO, sold, qLeft, shipFrom, shipTo, href, image,
                            image_vendor)


# called by the crawler to get description links on a listing page
# @param: beautifulsoup object that is using the correct html page (listing page)
# return: list of description links from a listing page
def zeroday_links_parser(soup):
    # Returning all links that should be visited by the Crawler

    href = []
    listings = soup.findAll('div', {"class": "ExploitTableContent"})

    for listing in listings:
        # Adding the url to the list of urls
        description_link = listing.find('h3').find('a')['href']
        href.append(description_link)

    return href
